CON
  _clkmode = xtal1 + pll8x         'Note Clock Speed for your setup!!                    
  _xinfreq = 10_000_000                                
  ird = 10                         'ir detector pin
  srl = 7                          'servo left            
  srr = 8                          'servo right
  pgs = 15                         'ping sensor
  pgm = 9                          'ping servo motor
  prl = 11                         'program running led
   
VAR
   byte ircode,rfcode              'recieved ircode, rfcode
   
OBJ
   ir : "irtest"                   'ir remote control reciever
   sr : "servo32v5"                'servo controller
   pg : "ping"                     'ping sensor
   rf : "rf"                       'rf reciever using parallax reciever #27980
   wt : "clock"                    'delay routine
       
PUB main | range
  rf.start(3,@rfcode)              
  ir.Start(ird, @ircode)           
  sr.set(srl, 1500)                
  sr.set(srr, 1500)
  sr.set(pgm, 1500) 
  sr.start
  ircode := 91
  dira[prl]~~
  repeat
    remote                         'go look and see if button is pressed on ir remote
    if rfcode == 1                 'if triggerbutton on joystick is pressed go get x,y value
      radio
    range := pg.millimeters(pgs)
    if range < 70
      revs
      wt.pausemsec(500)
      stop
      sonar
    !outa[prl]
        
pub remote 
  if rfcode == 1                   'if trigger on joystick pressed then exit
    return
  if ircode == 91                  'if buttons on ir remote pressed 
    stop                     
  if ircode == 116                 '      "             "        
    forw                         
  if ircode == 117                 '      "             " 
    revs                      
  if ircode == 52                  '      "             "  
    left                     
  if ircode == 51                  '      "             "    
    right                  
    
pub radio | x,y
  x := rf.a-127                    'get x value of joystick (will result w/ value of 0 - 255)
  y := rf.b-127                    'get y value of joystick (will result w/ value of 0 - 255)    
  sr.set(srl, 1500-y+x)            'set left servo to joystick x,y value
  sr.set(srr, 1500+y+x)            'set right servo to joystick x,y value
    
pub sonar | a,b
  sr.set(pgm, 1000)                'set ping sensor to look right
  wt.pausemsec(500)                'wait for servo to get there
  a := pg.millimeters(pgs)         'get distance
  sr.set(pgm, 2000)                'set ping sensor to look left 
  wt.pausemsec(500)                'wait for servo to get there    
  b := pg.millimeters(pgs)         'get distance  
  sr.set(pgm, 1500)                'recenter ping sensor
  wt.pausemsec(500)                'wait for servo to get there   
  if a < b                         'if there's more distance to the left of bot, turn left 
    left                           'turn left for a 1/2 second
    wt.pausemsec(500)
    stop 
  if a > b                         'if there's more distance to the right of bot, turn right     
    right                          'turn right for a 1/2 second
    wt.pausemsec(500)
    stop
            
pub stop  
  sr.set(srl, 1500)  
  sr.set(srr, 1500)
    
pub forw  
  sr.set(srl, 2000)               
  sr.set(srr, 1000)
    
pub revs  
  sr.set(srl, 1000)     
  sr.set(srr, 2000)
    
pub left  
  sr.set(srl, 1000)   
  sr.set(srr, 1000)
   
pub right  
  sr.set(srl, 2000)      
  sr.set(srr, 2000)  